#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[]) {
	
	FILE *input_file;
    FILE *output_file;
    
if(argc != 3) {
        printf("Usage: %s <in_file> <out_file> \n", argv[0]);
        printf("Parses an input file, generating an output file, consisting of those parts of the \n");
		printf("input file that are between an XON character and the next XOFF character. \n\n");
        return 1;
    }
    
    input_file = fopen(argv[1], "r");
    output_file = fopen(argv[2], "w");

    if(input_file == NULL || output_file == NULL) {
        printf("Error opening files");
        return 1;
    }

    int in_block = 0;
    char c;

    while((c = fgetc(input_file)) != EOF) {
        if(c == 0x11) { // XON character
            in_block = 1;
            continue;
        }

        if(c == 0x13) { // XOFF character
            in_block = 0;
            continue;
        }

        if(in_block) {
            fputc(c, output_file);
        }
    }

    fclose(input_file);
    fclose(output_file);

    return 0;
}
